#include <bits/stdc++.h>
#define endl '\n'
#define int long long
using namespace std;
//typedef long long int lint;

int xor_delilaca(int n){
    int k = 1;
    set<int> d;
    while(k <= sqrt(n)){
        if((n % k) == 0){
            d.insert(k);
            d.insert(n / k);
        }
        k++;
    }
    vector<int> dv;
    for(int x : d){
        dv.push_back(x);
    }
    int xorr;
    if(dv.size() >= 1){
        xorr = dv[0];
    }
    for(int i = 1; i < dv.size(); i++){
        xorr = xorr ^ dv[i];
    }
    return xorr;
}

void solve(){
    int n, k;
    cin >> n >> k;
    vector<int> d(k);
    for(int i = 0; i < k; i++){
        cin >> d[i];
    }
    for(int i = 0; i < k; i++){
        cout << xor_delilaca(d[i]) << " ";
    }
    cout << endl;
}


signed main(){
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t = 1;
    //cin >> t;
    while(t--){
        solve();
    }
    return 0;
}